@*A-Web --- Das Web-Werkzeug f\"ur Assemblersourcen.
Dieses Programm erlaubt es Assemblersourcen f\"ur den {\sl
nasm}-Assembler in einer Web-Sprache zu schreiben, die die Erstellung
von Source und Dokumentation in einem Rutsch erm\"oglicht. Im
Gegensatz zu den Originalprogrammen {\sl weave} und {\sl tangle}
werden hier beide m\"oglichen Programml\"aufe in einem Programm
realisiert. Die Unterscheidung erfolgt dann durch die Optionen des
Programms.
@c
#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#define FEHLER(n, m) fflush(NULL); fprintf(stderr,n, m); fflush(NULL);

#define	MOD_ANFANG	1
#define	MOD_AUFRUF	2
#define	MOD_SOURCE	3
#define	MOD_NULL	0

#define	ZLEN		1024
#define	ZLENREAD	512
#define	CYCLE		10
#define LISTLEN		9

#define	SHOWDOT		10
#define	SHOWNUM		50

#define	TRUE		-1
#define	FALSE		0

typedef	unsigned char bool;

struct zeile{
  struct zeile *next;
  char *text;};

struct modul{
  char *name;
  int	used;
  struct modul *next;
  struct zeile *kopf, *source;};

int		i, lines;
struct zeile	*zptr1, *zptr2, *zptr3;
struct modul	erstesmodul;
char		zeile1[ZLEN], zeile2[ZLEN];
char		lab[ZLEN], bef[ZLEN], ope[ZLEN], kom[ZLEN];
char		llab[ZLEN], lbef[ZLEN], lope[ZLEN], lkom[ZLEN];
char		liste[LISTLEN][2][ZLEN];

@<Unterprogramme@>@;
@<Hauptprogramm@>@;

@*Unterprogramme.
Im folgenden stehen alle Unterprogramme, die irgendwo mehrfach
gebraucht werden.
@<Unterprogramme@>=
@<Charakter@>@;
@<Semikolon@>@;
@<Parser@>@;
@<NoKommentar@>@;
@<Modulname@>@;
@<Modul kopieren@>@;
@<Ersatz@>@;
@<Addieren@>@;
@<File schreiben@>@;
@<Zeilen freigeben@>@;

@ Das folgende Unterprogramm gibt den {\sl Charakter} der
\"ubergebenen Zeile zur\"uck. M\"oglich sind dabei die Werte normal,
Modulaufruf, Sourcebeginn oder Moduldefinition.
@<Charakter@>=
int charakter(char *text){
  int ergebnis;
  char *zptr;

  ergebnis=MOD_NULL;
  zptr=text;
  while ((*zptr==' ') || (*zptr=='\t')) zptr++;
  if (*zptr=='@@'){
    zptr++;
    if (((*zptr <= '9') && (*zptr >= '0')) || (*zptr=='+')){
      if (*zptr=='+') ergebnis=MOD_SOURCE;
      else ergebnis=MOD_ANFANG;
    }
    else ergebnis=MOD_AUFRUF;
  }
  return(ergebnis);
}

@ Das folgende Unterprogramm gibt den Index auf das
kommentareinleitende Semikolon zur\"uck. Hat die \"ubergebene Zeile
keinen Kommentar, wird eine $-1$ zur\"uckgegeben. Als Erkennung wird
das erste Semikolon, das nicht in einem String steht verwendet.
@<Semikolon@>=
int semic(char *text){
  int ergebnis, i;
  bool inkom;

  ergebnis=-1;
  inkom=FALSE;
  for (i=0; i<strlen(text); i++){
    if ((text[i]==39) || (text[i]==34)){
      if (inkom) inkom=FALSE; else inkom=TRUE;}
    if ((text[i]==';') && (!inkom) && (ergebnis==-1)) ergebnis=i;}
  return(ergebnis);}

@ Das folgende Unterprogramm enth\"alt den Parser f\"ur die
Sourcezeilen. Jede Zeile wird in Label, Befehl, Operanden und
Kommentar zerlegt und dann noch getestet, ob eines der Felder l\"anger
ist, als das bisher l\"angste. Ist das der Fall, dann wird dieses Feld
zum neuen l\"amgsten Eintrag.
@<Parser@>=
void parse(char *text){
 int i;
 char puffer[ZLEN], *zptr, merker;

  for (i=0; i<ZLEN; i++){
    lab[i]='\0';
    bef[i]='\0';
    ope[i]='\0';
    kom[i]='\0';
  }

  strcpy(puffer, text);
  if (!((puffer[0] == '@@') && (puffer[1]=='+'))){
    @<Kommentar extrahieren@>@;
    if (puffer[0]){@<Label extrahieren@>@;}
    if (puffer[0]){@<Befehl extrahieren@>@;}
    if (puffer[0]) strcpy(ope, puffer);
  }
  if (strlen(lab) > strlen(llab)) strcpy(llab, lab);
  if (strlen(bef) > strlen(lbef)) strcpy(lbef, bef);
  if (strlen(ope) > strlen(lope)) strcpy(lope, ope);
  if (strlen(kom) > strlen(lkom)) strcpy(lkom, kom);
}

@ Das folgende Modul extrahiert den Kommentar aus einer Sourcezeile,
wenn denn einer darin steht. Der Kommentar wird dann entfernt und alle
anh\"angenden Blanks und Tabulatoren entfernt.
@<Kommentar extrahieren@>=
i=semic(puffer);
if (i != -1){
  zptr=&puffer[i];
  strcpy(kom, zptr);
  if (zptr==puffer) puffer[0]='\0';
  else{
    zptr--;
    while ((*zptr==' ') || (*zptr=='\t')) zptr--;
    zptr++;
    *zptr='\0';
  }
}

@ Nun folgt die Extraktion eines eventuell vorkommenden Labels. Label
beginnen grunds\"atzlich in der ersten Spalte der Zeile, es reicht
also zu testen, ob das erste Zeichen belegt ist. Wenn ein Label
gefunden wird, dann wird das Label aus der Zeile entfernt und alle
f\"uhrenden Leerzeichen ebenfalls, so da\ss{} danach ein eventueller
Befehl ganz zu Beginn der Zeile steht.
@<Label extrahieren@>=
if ((puffer[0] != ' ') && (puffer[0] != '\t')){
  zptr=puffer;
  while ((*zptr != ' ') && (*zptr != '\t') && (*zptr)) zptr++;
  merker=*zptr;
  *zptr='\0';
  strcpy(lab, puffer);
  *zptr=merker;
  if (merker){
    strcpy(puffer, zptr);
    zptr=puffer;
    while ((*zptr==' ') || (*zptr=='\t')) zptr++;
    strcpy(puffer, zptr);
  }
  else puffer[0]='\0';
}
else{
  zptr=puffer;
  while ((*zptr==' ') || (*zptr=='\t')) zptr++;
  if (*zptr) strcpy(puffer, zptr);
  else puffer[0]='\0';
}

@ Nun kann der Befehl extrahiert werden. Der Befehl besteht aus dem
gesamten ersten Wort. Hier an dieser Stelle wird nicht unterschieden,
ob ein Modulaufruf stattfindet oder nicht! Das mu\ss{} sp\"ater bei
der Erstellung der Dokumentation noch gesondert betrachtet werden.
@<Befehl extrahieren@>=
zptr=puffer;
while ((*zptr != ' ') && (*zptr != '\t') && (*zptr)) zptr++;
merker=*zptr;
*zptr='\0';
strcpy(bef, puffer);
*zptr=merker;
if (merker){
  strcpy(puffer, zptr);
  zptr=puffer;
  while ((*zptr==' ') || (*zptr=='\t')) zptr++;
  strcpy(puffer, zptr);
}
else puffer[0]='\0';

@ Das folgende Unterprogramm l\"oscht den Kommentar und alle dann noch
anh\"angenden Blanks und Tabulatoren aus einer Zeile.
@<NoKommentar@>=
void nokom(char *text){
  char *zptr;
  int i;

  i=semic(text);
  if (i != -1){
    zptr=&text[i];
    if (zptr==text) text[0]='\0';
    else{
      zptr--;
      while ((*zptr==' ') || (*zptr=='\t')) zptr--;
      zptr++;
      *zptr='\0';
    }
  }
}

@ Das folgende Unterprogramm gibt den Namen des aufgerufenen Moduls
zur\"uck.
@<Modulname@>=
void modname(char *text){
  char *zptr;

  strcpy(zeile2, text);
  nokom(zeile2);
  zptr=zeile2;
  while ((*zptr==' ') || (*zptr=='\t')) zptr++;
  zptr++;
  strcpy(zeile2, zptr);
}

@ Das folgende Unterprogramm kopiert einen Sourceteil an eine
bestimmte Zeile. \"Ubergeben werden ein Zeiger, wo der Source hin soll
und ein Zeiger auf den Namen des Moduls.
@<Modul kopieren@>=
void kopiere(struct zeile *z, char *name){
  struct zeile *von=NULL, *nach, *sicher;
  struct modul *mptr;

  mptr=&erstesmodul;
  while (mptr->next){
    mptr=mptr->next;
    if (strcmp(mptr->name, name)==0) von=mptr->source;
  }
  nach=z;
  while ((von) && (charakter(von->text) != MOD_ANFANG)){
    sicher=nach->next;
    nach->next=(struct zeile *)malloc(sizeof(struct zeile));
    nach=nach->next;
    nach->next=sicher;
    nach->text=(char *)malloc(strlen(von->text)+1);
    strcpy(nach->text, von->text);
    von=von->next;
  }
}

@ Das folgende Unterprogramm ersetzt Zeichen oder Zeichenfolgen in
einem String durch ein anderes Zeichen oder eine andere Zeichenfolge.
Die zu ersetzenden Zeichen werden in einer Variablenliste
bereitgestellt. Die Zeile, in der ersetzt werden soll mu\ss{}
physikalisch im Speicher vorliegen und es mu\ss{} sichergestellt sein,
da\ss{} sie lang genug ist.
@<Ersatz@>=
void ersetze(char *text){
  char von[ZLEN], nach[ZLEN], *c1, *c2;
  int i, j;
  bool gefunden;

  for (i=0; i<ZLEN; i++){
    von[i]='\0';
    nach[i]='\0';
  }
  strcpy(von, text);
  c1=von; c2=nach;
  while (*c1){
    gefunden=FALSE;
    for (i=0; i<LISTLEN; i++){
      if (strncmp(liste[i][0], c1, strlen(liste[i][0]))==0){
        gefunden=TRUE;
	strcat(nach, liste[i][1]);
	while (*c2) c2++;
	for (j=0; j<strlen(liste[i][0]); j++) c1++;
      }
    }
    if (!gefunden){
      *c2=*c1;
      c1++;
      c2++;
      *c2='\0';
    }
  }
  strcpy(text, nach);
}

@ Das folgende Unterprogramm h\"angt an die Struktur, auf die der
\"ubergebene Zeiger zeigt eine Zeile an. Die Zeile wird ebenfalls
\"ubergeben.
@<Addieren@>=
void addiere(struct zeile *z, char *text){
  z->next=(struct zeile *)malloc(sizeof(struct zeile));
  z=z->next;
  z->next=NULL;
  z->text=(char *)malloc(strlen(text)+1);
  strcpy(z->text, text);
}

@ Das folgende Unterprogramm schreibt alle Zeilen, die am
\"ubergebenen Pointer h\"angen in den File, dessen Name auch \"uber
geben wird.
@<File schreiben@>=
void writef(struct zeile *z, char *name){
  int lines;
  FILE *fp;

  lines=0;
  fp=fopen(name, "w");
  if (fp){
    printf(".");
    while (z->next){
      z=z->next;
      fprintf(fp, "%s\n", z->text);
      lines++;
      if ((lines % SHOWDOT) == 0) printf(".");
      if ((lines % SHOWNUM) == 0) printf("%i",lines);
    }
    printf("\n");
  }
  else printf("File >%s< kann nicht geschrieben werden!\n", name);
}

@ Das folgende Unterprogramm gibt alle Zeilen ab der \"ubergebenen
frei. Die \"ubergebene Zeile darf dabei nicht freigegeben werden.
@<Zeilen freigeben@>=
void freelines(struct zeile *z){
  struct zeile *z1, *z2;

  do{
    z1=z; z2=z;
    while (z1->next){
      z2=z1;
      z1=z1->next;
    }
    if (z1 != z){
      if (z1->text) free(z1->text);
      free(z1);
    }
    z2->next=NULL;
  } while (z->next);
}
  
@*Hauptprogramm.
Das Hauptprogramm initialisiert einige Variablen und testet die
Argumente. Danach wird der Eingabefile eingelesen und ein kurzer Check
durchgef\"uhrt. Je nach Flaglage wird dann Source oder Dokumentation
erzeugt.
@<Hauptprogramm@>=
int main(int argc, char *argv[]){
  int		ergebnis;
  bool		argok, modulok, mda, intex, insource;
  bool		weave, tangle, verbatim;
  char		*zptr;
  FILE		*infile=NULL;
  char		infname[ZLEN], asmfname[ZLEN], texfname[ZLEN];
  struct zeile	inroot, asmroot, texroot;
  struct modul	*mptr1, *mptr2;

  printf("\nA-Web 1.0\n=========\n");
  @<Initialisieren von Variablen@>@;
  @<Testen der Argumente@>@;
  if (argok){
    @<Einlesen des Eingabefiles@>@;
    @<Modulcheck@>@;
    if (modulok){
      if (tangle){@<Source erzeugen@>@;}
      if (weave){@<Dokumentation erzeugen@>@;}
    }
    @<Deinitialisierung@>@;
  }
  else{
    ergebnis=-1;
    printf("Aufruf:\n\n");
    printf("aweb -<tw>[v] filename\n");
    printf("  t : Sourceerzeugung\n");
    printf("  w : Dokumenterzeugung\n");
    printf("  v : Informationen zum Programmlauf\n");
  }
  return(ergebnis);
}

@ Manche Variablen m\"ussen vorbesetzt werden. Das geschieht in diesem
Modul.
@<Initialisieren von Variablen@>=
ergebnis=0;
argok=FALSE;
weave=FALSE;
tangle=FALSE;
verbatim=FALSE;

inroot.next=NULL; inroot.text=NULL;
asmroot.next=NULL; asmroot.text=NULL;

erstesmodul.name=NULL; erstesmodul.used=0;
erstesmodul.next=NULL; erstesmodul.kopf=NULL; erstesmodul.source=NULL;

for (i=0; i<ZLEN; i++){
  llab[i]='\0';
  lbef[i]='\0';
  lope[i]='\0';
  lkom[i]='\0';
}

strcpy(liste[0][0], "$"); strcpy(liste[0][1], "\\$");
strcpy(liste[1][0], "&"); strcpy(liste[1][1], "\\&");
strcpy(liste[2][0], "%"); strcpy(liste[2][1], "\\%");
strcpy(liste[3][0], "#"); strcpy(liste[3][1], "\\#");
strcpy(liste[4][0], "_"); strcpy(liste[4][1], "\\_");
strcpy(liste[5][0], "<"); strcpy(liste[5][1], "$<$");
strcpy(liste[6][0], ">"); strcpy(liste[6][1], "$>$");
strcpy(liste[7][0], "\t"); strcpy(liste[7][1], " ");
strcpy(liste[8][0], " "); strcpy(liste[8][1], " ");

@ Nun k\"onnen die Argumente getestet werden. Insbesondere mu\ss{} die
Option {\tt t} oder die Option {\tt w} angegeben sein und der
Eingabefile exisitieren und ein Webfile sein.
@<Testen der Argumente@>=
if (argc == 3){
  zptr=argv[1];
  if (*zptr=='-'){
    zptr++;
    while (*zptr){
      switch (*zptr){
        case 'v' : {verbatim=TRUE; break;}
	case 't' : {tangle=TRUE; break;}
	case 'w' : {weave=TRUE; break;}
      }
      zptr++;
    }
  }
  strcpy(infname, argv[2]);
  infile=fopen(infname, "r");
  if ((infile) && ((tangle) || (weave))) argok=TRUE;
}

@ Im folgenden Modul wird der Eingabefile in den Speicher gelesen. Es
werden einfach die Zeilen der Reihe nach im Speicher abgelegt. Leere
Zeilen werden dabei ignoriert und immer das Zeilenende abgeschnitten.
@<Einlesen des Eingabefiles@>=
if (verbatim){
  printf("Vorbereitungen\n");
  printf("--------------\n");
  if (tangle) printf("Erzeuge Source\n");
  if (weave) printf("Erzeuge Dokumentation\n");
  printf("Einlesen des Eingabefiles\n");
}
lines=0;
printf(".");
do{
  for (i=0; i<ZLEN; i++) zeile1[i]='\0';
  fgets(zeile1, ZLENREAD, infile);
  if (zeile1[0]){
    zeile1[strlen(zeile1)-1]='\0';
    if (zeile1[0]){
      lines++;
      if (verbatim){
        if ((lines % SHOWDOT) == 0) printf(".");
	if ((lines % SHOWNUM) == 0) printf("%i", lines);
      }
      zptr1=&inroot;
      while (zptr1->next) zptr1=zptr1->next;
      addiere(zptr1, zeile1);
      zptr1=zptr1->next;
    }
    else zeile1[0]='x';
  }
} while (zeile1[0]);
printf("\n");

@ Im folgenden Modul steht der Modulcheck. Er ist gegen\"uber der
vorherigen Version stark erweitert. Zun\"achst werden einfach nur alle
Module in die Modulliste eingetragen und alle Sourcezeilen durch den
Sourceparser gejagt, damit schon die Werte f\"ur die
Tabulatorsetzungen bekannt sind. Beim zweiten Lauf wird dann getestet,
ob jedes aufgerufene Modul auch existiert.
@<Modulcheck@>=
if (verbatim) printf("Modulcheck; erster Durchlauf\n");
modulok=TRUE;
intex=FALSE;
insource=FALSE;
zptr1=&inroot;
while (zptr1->next){
  zptr1=zptr1->next;
  switch(charakter(zptr1->text)){
    case MOD_ANFANG : {@<Neues Modul@>@; intex=TRUE; insource=FALSE; break;}
    case MOD_SOURCE : {@<Neuer Source@>@; intex=FALSE; insource=TRUE; break;}
  }
  if (insource) parse(zptr1->text);
}
erstesmodul.next->used=1;
if (verbatim){
  printf("Laengstes Label     : %s\n", llab);
  printf("Laengster Befehl    : %s\n", lbef);
  printf("Laengster Operand   : %s\n", lope);
  printf("Laengster Kommentar : %s\n", lkom);
  printf("Modulcheck; zweiter Durchlauf\n");
}
zptr1=&inroot;
while (zptr1->next){
  zptr1=zptr1->next;
  if (charakter(zptr1->text)==MOD_AUFRUF){
    modname(zptr1->text);
    if (verbatim) printf("Bearbeite Aufruf von >%s<\n", zeile2);
    mda=FALSE;
    mptr1=&erstesmodul;
    while (mptr1->next){
      mptr1=mptr1->next;
      if (strcmp(mptr1->name, zeile2)==0){
        mptr1->used++;
	mda=TRUE;
      }
    }
    if (!mda){
      modulok=FALSE;
      printf("Modul >%s< nicht gefunden\n", zeile2);
    }
  }
}
mptr1=&erstesmodul;
if (mptr1->next==NULL){
  printf("Kein erstes Modul definiert!\n");
  modulok=FALSE;
}
else{
  while (mptr1->next){
    mptr1=mptr1->next;
    if (mptr1->used == 0)
      printf("Warnung: Modul >%s< wird nicht genutzt\n", mptr1->name);
    mptr1->used=0;
  }
  erstesmodul.next->used=1;
}

@ Ein neues Modul wurde gefunden. Dieses mu\ss{} nun in die Modulliste
eingetragen werden und alle schon bekannten Daten \"ubertragen werden.
@<Neues Modul@>=
mptr1=&erstesmodul;
while (mptr1->next) mptr1=mptr1->next;
mptr1->next=(struct modul *)malloc(sizeof(struct modul));
mptr1=mptr1->next;
mptr1->name=(char *)malloc(strlen(zptr1->text)-1);
strcpy(mptr1->name, &(zptr1->text[2]));
mptr1->used=0;
mptr1->next=NULL;
mptr1->kopf=zptr1->next;
mptr1->source=NULL;
if (verbatim) printf("Moduldefinition >%s< gefunden\n", mptr1->name);
if (intex){
  modulok=FALSE;
  mptr1=&erstesmodul; mptr2=&erstesmodul;
  while (mptr1->next){
    mptr2=mptr1;
    mptr1=mptr1->next;
  }
  printf("Moduldefinition von >%s< nicht vollstaendig\n", mptr2->name);
}

@ Wurde ein neuer Sourcebeginn gefunden, dann mu\ss{} der in den
letzten Eintrag der Modulliste eingetragen werden.
@<Neuer Source@>=
mptr1=&erstesmodul;
while (mptr1->next) mptr1=mptr1->next;
mptr1->source=zptr1->next;
if (verbatim) printf("Source von >%s< gefunden\n", mptr1->name);

@*Sourceerzeugung.
Ab hier wird nun der Source erzeugt. Diese Arbeit erfolgt in drei
Schritten. Zun\"achst wird das erste Modul nach |asmroot| kopiert.
Danach wird solange jeder Modulaufruf durch den entsprechenden Source
ersetzt, bis kein Modulaufruf mehr im Text steht. Zum Abschlu\ss{}
werden alle Zeilen ab |asmroot| in den Ausgabefile geschrieben.
@<Source erzeugen@>=
if (verbatim){
  printf("\nAusgabe des Sourcefiles\n");
  printf("-----------------------\n");
}
modulok=TRUE;
@<Erstes Modul kopieren@>@;
@<Ersetzen der Modulaufrufe@>@;
@<Kommentare entfernen@>@;
if (modulok){@<Assemblerfile schreiben@>@;}

@ Im folgenden Modul wird das erste Modul nach |asmroot| kopiert. Die
eigentliche Arbeit erledigt ein Unterprogramm, welches einen
Zielzeiger und einen Namen \"ubergeben bekommt.
@<Erstes Modul kopieren@>=
if (verbatim) printf("Kopiere erstes Modul\n");
zptr1=&asmroot;
zptr=erstesmodul.next->name;
kopiere(zptr1, zptr);

@ Nun kommt der eigentlich schwierige Teil. Die Zeilen ab |asmroot|
m\"ussen so lange durchlaufen werden, bis entweder ein Modul so oft
aufgerufen wurde, da\ss{} es auf einen Fehler hindeutet, oder kein
Modulaufruf mehr im Source vorkommt.
@<Ersetzen der Modulaufrufe@>=
do{
  mda=FALSE;
  zptr1=&asmroot;
  while (zptr1->next){
    zptr1=zptr1->next;
    if (charakter(zptr1->text)==MOD_AUFRUF){@<Modulersatz@>@;}
  }
} while ((mda) && (modulok));

@ Das eigentliche Ersetzen des Moduls geschieht hier in einem eigenen
Modul. Die Sourcezeilen werden an die Aufrufzeile angeh\"angt und
danach erst die aufrufende Zeile gel\"oscht.
@<Modulersatz@>=
mda=TRUE;
modname(zptr1->text);
mptr1=&erstesmodul;
while (mptr1->next){
  mptr1=mptr1->next;
  if (strcmp(zeile2, mptr1->name)==0) mptr1->used++;
  if (mptr1->used > CYCLE){
    modulok=FALSE;
    printf("Modul >%s< wurde zu oft aufgerufen!\n", zeile2);
  }
}
if (verbatim) printf("Ersetze >%s<\n", zeile2);
if (modulok){
  kopiere(zptr1, zeile2);
  zptr2=&asmroot;
  while (zptr2->next != zptr1) zptr2=zptr2->next;
  zptr2->next=zptr1->next;
  free(zptr1->text);
  free(zptr1);
  zptr1=zptr2->next;
}

@ Die eigentliche Arbeit macht mal wieder ein Unterprogramm, aber der
Durchlauf durch den Source wird hier noch realisiert.
@<Kommentare entfernen@>=
zptr1=&asmroot;
while (zptr1->next){
  zptr1=zptr1->next;
  nokom(zptr1->text);
}

@ Nun mu\ss{} nur noch der Name des Assemblerfiles erzeugt werden und
dann alles in die Ausgabe geschrieben werden.
@<Assemblerfile schreiben@>=
strcpy(asmfname, infname);
asmfname[strlen(asmfname)-1]='\0';
strcat(asmfname, "asm");
zptr1=&asmroot;
writef(zptr1, asmfname);

@*Dokumentationserzeugung.
Ab hier wird nun die Dokumentation erzeugt. Da eventuell daran gedacht
ist au\ss{}er der \TeX-Ausgabe auch Alternativen wie RTF zuzulassen,
mu\ss{} diese Routine etwas flexibler gehandhabt werden. Zun\"achst
wird allerdings nur die \TeX-Ausgabe implementiert.

Die Dokumenterzeugung ist wesentlich einfacher, als die
Sourceerzeugung. Es mu\ss{} nur untersucht werden, ob man sich im
\TeX-Teil des Moduls befindet, oder im Source. Vor dem ersten Modul
darf auch noch was anderes stehen, das dann {\sl wie es ist} in den
Ausgabefile \"ubernommen wird. Besonders behandelt werden die Zeilen,
die ein Modul definieren, oder die den Sourceteil einleiten.
@<Dokumentation erzeugen@>=
@<Vor-\TeX@>@;
intex=FALSE; insource=FALSE;
zptr1=&inroot;
zptr2=&texroot;
while (zptr2->next) zptr2=zptr2->next;
while (zptr1->next){
  zptr1=zptr1->next;
  for (i=0; i<ZLEN; i++) zeile1[i]='\0';
  if ((charakter(zptr1->text)==MOD_ANFANG) ||
      (charakter(zptr1->text)==MOD_SOURCE)){
    if (charakter(zptr1->text)==MOD_ANFANG){
      @<\"Uberschrift@>@;
      intex=TRUE;
      insource=FALSE;
    }
    else{
      intex=FALSE;
      insource=TRUE;
      strcpy(zeile1,"\\medskip");
      addiere(zptr2, zeile1);
      zptr2=zptr2->next;
    }
  }
  else{
    if (insource){
      parse(zptr1->text);
      ersetze(lab);
      ersetze(bef);
      ersetze(ope);
      ersetze(kom);
      strcpy(zeile1, "\\+ ");
      strcat(zeile1, lab);
      strcat(zeile1, " & ");
      if (bef[0]=='@@'){
        strcat(zeile1, bef);
	strcat(zeile1, " ");
	strcat(zeile1, ope);
	strcat(zeile1, " & & ");
      }
      else{
        strcat(zeile1, bef);
	strcat(zeile1, " & ");
	strcat(zeile1, ope);
	strcat(zeile1, " & ");
      }
      strcat(zeile1, kom);
      strcat(zeile1, " \\cr");
    }
    else strcpy(zeile1, zptr1->text);
    addiere(zptr2, zeile1);
    zptr2=zptr2->next;
  }
}
addiere(zptr2, "\\inhaltsverzeichnis");
zptr2=zptr2->next;
addiere(zptr2, "\\end");
strcpy(texfname, infname);
texfname[strlen(texfname)-1]='\0';
strcat(texfname, "tex");
writef(&texroot, texfname);

@ Bevor die eigentlichen Zeilen ausgegeben werden k\"onnen mu\ss{} der
Makrofile eingelesen werden und die Tabulatoren definiert werden.
@<Vor-\TeX@>=
strcpy(zeile1, "\\input awebmac");
zptr1=&texroot;
addiere(zptr1, zeile1);
zptr1=zptr1->next;
ersetze(llab);
ersetze(lbef);
ersetze(lope);
ersetze(lkom);
strcpy(zeile1, "\\settabs\\+ ");
strcat(zeile1, llab);
strcat(zeile1, "\\quad\\quad & ");
strcat(zeile1, lbef);
strcat(zeile1, "\\quad\\quad & ");
strcat(zeile1, lope);
strcat(zeile1, "\\quad\\quad & ");
strcat(zeile1, lkom);
strcat(zeile1, " \\cr");
addiere(zptr1, zeile1);
zptr1=zptr1->next;

@ Die \"Uberschrift f\"ur ein Modul zu erzeugen ist etwas aufwendiger,
als eine normale Textzeile, da hier auch noch ein Makro aufgerufen
werden mu\ss{}. Daher steht es in einem eigenen Modul.
@<\"Uberschrift@>=
switch (zptr1->text[1]){
  case '1' : {strcpy(zeile1, "\\EINS{"); break;}
  case '2' : {strcpy(zeile1, "\\ZWEI{"); break;}
  case '3' : {strcpy(zeile1, "\\DREI{"); break;}
  case '4' : {strcpy(zeile1, "\\VIER{"); break;}
  case '5' : {strcpy(zeile1, "\\FUEN{"); break;}
  case '6' : {strcpy(zeile1, "\\SECH{"); break;}
  default  : {strcpy(zeile1, "\\SECH{"); break;}
}
strcat(zeile1, &zptr1->text[2]);
strcat(zeile1, "}");
addiere(zptr2, zeile1);
zptr2=zptr2->next;

@*Deinitialisierung.
Vieles mu\ss{} auch wieder deinitialisiert werden. Der Eingabefile
mu\ss{} wieder freigegeben werden und die verschiedenen Speicher
m\"ussen wieder freigegeben werden.
@<Deinitialisierung@>=
if (verbatim){
  printf("\nBeendigung des Programms\n");
  printf("------------------------\n");
  printf("Freigabe des Eingabefiles\n");
}
fclose(infile);

if (verbatim) printf("Freigabe der Originalzeilen\n");
freelines(&inroot);

if (verbatim) printf("Freigabe der Sourcezeilen\n");
freelines(&asmroot);

if (verbatim) printf("Freigabe der Modulliste\n");
do{
  mptr1=&erstesmodul; mptr2=&erstesmodul;
  while (mptr1->next){
    mptr2=mptr1;
    mptr1=mptr1->next;
  }
  if (mptr1->name) free(mptr1->name);
  if (mptr1 != &erstesmodul) free(mptr1);
  mptr2->next=NULL;
} while (erstesmodul.next);

