@1Rot-13
Hier das Kopfmodul einer ROT-13-Funktion in A-WEB. Dieses Programm
dient eigentlich nur der Dokumentation von A-WEB und nicht so sehr
einem echten Programm, aber da ich auch vorhabe die M\"oglichkeiten
von A-WEB darzustellen, sollte ein kleines Programm nicht fehlen.

Der Aufbau der Routine ist sehr einfach. Es werden so lange Zeichen
eingelesen, bis eines der Zeichen ein EOF ($=-1$) ist. Jedes
eingelesene Zeichen wird dann ROT-13 kodiert und wieder ausgegeben.

Wird das Zeichen EOF gelesen, dann wird das Programm beendet.

Nun folgt der Source des ersten Moduls.
@+
	@Festlegungen		; Assemblerdirektiven u.\"a.
	@Main-Loop		; Die Hauptschleife
	@Ende			; Beendigung des Programms
	@Unterprogramme		; Hier liegen die Unterprogramme

@2Festlegungen
In diesem Modul werden die Festlegungen f\"ur den NASM-Assembler
getroffen, sowie einige Konstanten definiert.
@+
BITS 32
GLOBAL _start

%assign	EOF		0
%assign	SYSEXIT		1
%assign	SYSREAD		3
%assign	SYSWRITE	4

SECTION	.data
puffer	db	0,0,0,0			; Datenpuffer
SECTION	.text

@2Main-Loop
Hier steht nun der Main-Loop. Es werden so lange Zeichen eingelesen,
bis das Zeichen EOF gefunden wird. Die \"Uberpr\"ufung erfolgt
sicherlich nicht gerade wunderbar, aber sie tut ihren Zweck.
@+
_start:	mov	eax, SYSREAD		; Funktionsnummer
	xor	ebx, ebx		; Standardeingabe=0
	mov	ecx, puffer		; Zeiger auf Puffer
	mov	edx, 1			; Nur ein Zeichen
	int	0x80			; Und lesen

	or	eax, eax		; wenn nichts mehr kommt
	je	exit			; Ende

	call	rot13			; sonst umwandeln und
	jmp	_start			; dann erst weiter

@2Ende
Nun kann das Programm auch wieder beendet werden. Dazu wird eigentlich
nur ein Label bereit gestellt und hinter diesem die LINUX-Funktion
EXIT angesprungen
@+
exit:	mov	eax, SYSEXIT		; Funktionsnummer
	mov	ebx, 0			; R\"uckgabewert
	int	0x80			; Ab daf\"ur

@1Unterprogramme
Hier findet nun die Umwandlung des Zeichens und dann dessen Ausgabe
statt. Vorausgesetzt wird, da\ss{} das Zeichen bei {\tt puffer} liegt.
@+
rot13:	mov	al, [puffer]		; Zeichen holen
	@Rotieren			; Umwandeln
	mov	[puffer], al		; Zur\"uck in den Puffer
	mov	eax, SYSWRITE		; Funktionsnummer
	mov	ebx, 1			; Standardausabe
	mov	ecx, puffer		; Zeiger auf Puffer
	mov	edx, 1			; L\"ange ein Zeichen
	int	0x80			; Ausgeben
	ret				; und Ende

@2Rotieren
In diesem Modul findet das eigentlich Rotieren des Zeichens statt. Es
wird davon ausgegangen, da\ss{} das Zeichen im Register {\tt eax}
liegt und auch dort verarbeitet werden kann.
@+
	cmp	byte al, 'Z'		; wenn kleiner oder gleich
	jle	short gross		; 'Z', Grossbuchstabe
	cmp	byte al, 'a'		; wenn groesser oder gleich
	jge	short klein		; 'a' Kleinbuchstabe
	jmp	short endrot		; sonst Ende
	@Gro\ss{}buchstaben		; Gro\ss{}buchstaben
	@Kleinbuchstaben		; Kleinbuchstaben
endrot:	

@3Gro\ss{}buchstaben
Im folgenden Modul wird zuerst getestet, ob es sich wirklich um einen
Gro\ss{}buchstaben handelt. Ist das nicht der Fall, wird ans Ende des
Moduls gesprungen.Erst, wenn klar ist, da\ss{} es sich wirklich um
einen Gro\ss{}buchstaben handelt, wird entschieden, wie er ver\"andert
wird.
@+
gross:	cmp	byte al, 'A'		; wenn kleiner als 'A'
	jl	endrot			; Ende
	cmp	byte al, 'M'		; ist er nun gr\"o\ss{}er
	jg	short gsub		; als 'M', subtrahieren
	add	byte al, 13		; sonst addieren
	jmp	short endrot		; und Ende
gsub:	sub	byte al, 13		; hier subtrahieren
	jmp	short endrot		; und Ende

@3Kleinbuchstaben
In diesem Modul passiert praktish das Gleiche, wie bei den
Gro\ss{}buchstaben. Sicherlich ist das {\bf sehr} ineffizienter Kode,
aber es dient ja auch nur der Demonstration von A-Web.
@+
klein:	cmp	byte al, 'a'		; wenn kleiner als 'a'
	jl	endrot			; Ende
	cmp	byte al, 'm'		; ist er nun gr\"o\ss{}er
	jg	short ksub		; als 'm', subtrahieren
	add	byte al, 13		; sonst addieren
	jmp	short endrot		; und Ende
ksub:	sub	byte al, 13		; hier subtrahieren
	jmp	short endrot		; und Ende


